#include "NonEmptyList.h"

template<class C>
NonEmptyList<C>::NonEmptyList (C f, List *r)
{
	first = f;
	rest = r;
}

template<class C>
NonEmptyList<C>::NonEmptyList (const NonEmptyList<C> &other)
{
	first = other.first;
	rest = other.rest;
}

template<class C>
C NonEmptyList<C>::getFirst () const
{
	return first;
}

template<class C>
List<C> * NonEmptyList<C>::getRest () const {
	return rest;
}

template<class C>
int NonEmptyList<C>::length () const
{
	return 1 + rest->length ();
}

template<class C>
string NonEmptyList<C>::descrHelper () const
{
	return " " + first + rest->descrHelper();
}

template<class In,class Out>
List<Out> * NonEmptyList<In>::map (Out (*f)(In)) 
{
	return new NonEmptyList<Out> ((*f)(first), rest->map(f));
}
